Name:		hp-igb
Version:	5.3.3.2
Release:	4.%{distro}
Group:		System/Kernel
Vendor:		Intel Corporation
URL:		http://support.intel.com/support/go/igb.htm
Packager:	Hewlett-Packard Company
License:	GPL
Source0:	%{name}-%{version}.tar.gz
Source1:        %{name}.files
BuildRoot:	%{_tmppath}/%{name}-%{version}-build
Summary:	HP Intel Gigabit Ethernet driver (igb)

%define debug_package %{nil}

%if "%{_vendor}" == "suse"
%if %{!?KVER:1}%{?KVER:0}
%ifarch x86_64
%define flav default kdump smp xen
%else
%define flav default bigsmp kdump kdumpae smp xen xenpae pae
%endif
%endif

%if %{!?KVER:0}%{?KVER:1}
%define flav %(echo %{KVER} | awk -F"-" '{print $3}')
%endif
%endif

%if "%{_vendor}" == "redhat"
%if %{!?KVER:1}%{?KVER:0}
%define flav ""
%endif
%if %{!?KVER:0}%{?KVER:1}
%define flav %(echo %{KVER} | awk -F"el5" '{print $2}')
%if "%{flav}" == ""
%define flav default
%endif
%endif
%endif

%if "%{_vendor}" == "suse"
BuildRequires: kernel-source kernel-syms
%define install_mod_dir updates/%{name}
%define kernel_source /usr/src/linux-obj/%{_target_cpu}
%{suse_kernel_module_package -x %flav}
%else
BuildRequires: %kernel_module_package_buildreqs
%define install_mod_dir extra/%{name}
%{kernel_module_package -f %{SOURCE1} %flav}
%endif

%description
Intel(R) Gigabit Ethernet Kernel Module for HP ProLiant systems
SRPMS available at http://downloads.linux.hp.com/SDR/repo/spp/<spp version>/hp/source
Public key available at https://h20392.www2.hp.com/portal/swdepot/displayProductInfo.do?productNumber=HPLinuxCodeSigning

%package KMP
Summary: HP Intel Gigabit Ethernet driver (igb)
Group: System/Kernel

%description KMP
Intel(R) Gigabit Ethernet Kernel Module for HP ProLiant systems
SRPMS available at http://downloads.linux.hp.com/SDR/repo/spp/<spp version>/hp/source
Public key available at https://h20392.www2.hp.com/portal/swdepot/displayProductInfo.do?productNumber=HPLinuxCodeSigning

%package doc
Summary: Documentation for the %{name} kernel module
Group: System/Kernel
%if "%{_vendor}" == "redhat"
Requires: %{name}-kmod = %{version}-%{release}
%else
Requires: %{name}-kmp
%endif

%description doc
Documentation for the HP Intel Gigabit Ethernet driver (igb)

%prep
%setup
mkdir source
set -- src/*
mv src/* source/
mkdir obj
echo "override igb * weak-updates/%{name}" > %{name}.conf

%build
export EXTRA_CFLAGS='-DVERSION="%version"'

%if %{!?KVER:0}%{?KVER:1}
%define flavors %{flav}
%else
%define flavors %{flavors_to_build}
%endif

for flavor in %{flavors}; do
	rm -rf obj/$flavor
	cp -r source obj/$flavor
	make -C %{kernel_source $flavor} M=$PWD/obj/$flavor

	#mark modules executable so that strip-to-file can strip them
	find obj/$flavor/ -name "*.ko" -type f -exec chmod u+x '{}' +
done
gzip < igb.7 > igb.7.gz

%install
export INSTALL_MOD_PATH=$RPM_BUILD_ROOT
export INSTALL_MOD_DIR=%install_mod_dir

%if %{!?KVER:0}%{?KVER:1}
%define flavors %{flav}
%else
%define flavors %{flavors_to_build}
%endif

for flavor in %{flavors}; do
	make -C %{kernel_source $flavor} modules_install M=$PWD/obj/$flavor

	#Cleanup unnecessary kernel-generated module dependency files.
	find $INSTALL_MOD_PATH/lib/modules -iname 'modules.*' -exec rm {} \;
done
install -D -m 644 igb.7.gz $RPM_BUILD_ROOT/%{_mandir}/man7/igb.7.gz
install -d %{buildroot}%{_sysconfdir}/depmod.d/
install %{name}.conf %{buildroot}%{_sysconfdir}/depmod.d/

%postun doc
if [ -f %{_mandir}/man7/igb.7.gz ]; then
	exit 0
fi

%clean
rm -rf %{buildroot}

%files
%{_sysconfdir}/depmod.d/%{name}.conf

%files doc
%defattr(-, root, root)
%{_mandir}/man7/igb.7.gz
%doc COPYING README

%changelog
* Mon Oct 19 2015 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> %version-%release
 - Added SLES12SP1 support
 - Added RHEL 7.2 support
 - Fix queue allocation method to accomodate changing during runtime
 - Use skb_vlan_tag_* functions instead of old name vlan_tx_tag
 - This driver addresses an issue where the link speed reported by the HPE Active Health System (AHS) is incorrect.
 - This driver can now correctly change the queue allocation method during runtime.

* Tue Jul 07 2015 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 5.2.17-11
 - Added SLES11SP4 support
 - Added RHEL 6.7 support

* Tue Mar 17 2015 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 5.2.17-2
 - Added RHEL 7.1 support
 - Fixes a Tx Unit Hang on Network Adapters based on Intel 82576 chipset(NC362i) with RSS > 1

* Wed Oct 28 2014 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 5.2.15
 - Added SLES 12 support
 - Added RHEL 6.6 support
 - Added support for Surprise Removal of a NIC

* Wed May 21 2014 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 5.0.7-10

* Wed Nov 27 2013 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 5.0.7-4
 - Fixed igb compilation issues with upstream 3.10 Linux Kernel
 - Changed how driver update rx packet stats, to include additional packet types
 - Add support for freeing q_vectors via RCU

* Mon Jul 15 2013 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 4.3.0-5
 - Add support for OEM Powerville-based SKUs (Severity: Medium)
